//  ##########                     #                       ##########
//  ##########          Crop plants of Indiana             ##########
//  ##########   An include file for creating crop fields  ##########
//  ##########         Jeff Holland, April 2009            ##########
//  ##########                     #                       ##########
//  ##########                     #                       ##########


//Plants available:
//  corn
//  cornfield - 6 x 6 units
//  soybean  - a bad model
//  beanfield  - a whole field of bad models


#declare cornleaf = union {
intersection {
  difference {
    sphere { <0, 0.25, 0>, 0.25
      pigment {color GreenYellow} 
      scale y*4
      }
   sphere { <0, 0.25, 0>, 0.249
      pigment {color GreenYellow} 
      scale y*4
      }
      }  //  end difference 
 prism {
    linear_spline
     0, 2, 4,
     <0,0>, <2,0.25>, <2,-0.25>, <0,0> 
     pigment {color Green}     
     rotate z*8     
          }
 scale x*0.5
 }  //  end corn leaf intersection
};  // end corn leaf declare

#declare corn =  
  difference {
   union {
      object {cornleaf translate <-0.13, -0.15, 0>}
      object {cornleaf rotate y*120 translate <0.06, 0, 0.13>}
      object {cornleaf rotate y*240 translate <0.06, 0.15, -0.13>}
      cone {<0, 0.7, 0>, 0.01, <0, 2.1, 0>, 0.005
         pigment {color Yellow} }   
     translate y*-0.5 
     }  //  end union of leaves and stalk
  box {<-2, 0, -2>, <1, -3, 1>}
  };  //  end difference to chop at ground
  
//  ========== Corn Fields  ==========

#declare cornz = 0;  #declare cornx = 0;
#declare cornrow = union {
   #while (cornz < 6)
      object {corn translate z*cornz}
      #declare cornz = cornz+0.25;
   #end
   }  //  end cornrow
#declare cornfield = union {
   #while (cornx < 6)
      object {cornrow translate x*cornx}
      #declare cornx = cornx+0.5;
   #end
   }  //  end cornfield     
   

//  ==========  Soybean  ==========kinda

#declare soybean = union {
sphere {
    <0, 0.25, 0>, 0.25 
    texture {
      pigment { color YellowGreen }
      normal { bumps 4 scale 0.06 }
      finish { phong 0.1 }
      }  //  end texture
    }  //  end sphere
};  //  end soybean plant.  kinda.
       
//  ========== Soybean Fields  ==========

#declare beanz = 0.5;  #declare beanx = 0.5;
#declare beanrow = union {
   #while (beanz < 6)
      object {soybean translate y*0.1 translate z*beanz}
      #declare beanz = beanz+0.5;
   #end
   }  //  end beanrow
#declare beanfield = union {
   #while (beanx < 6)
      object {beanrow translate x*beanx}
      #declare beanx = beanx+0.5;
   #end
   }  //  end beanfield   